"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getErrorHandlerMiddleware = void 0;
var http_status_codes_1 = require("http-status-codes");
;
;
exports.getErrorHandlerMiddleware = function (log) {
    return function (err, req, res, 
    // eslint-disable-next-line @typescript-eslint/no-unused-vars
    next) {
        log(req.method + " request to " + req.originalUrl + "  has failed with error: " + err.message);
        var errorResponse = {
            message: err.message
        };
        var responseStatusCode = err.statusCode === undefined ? http_status_codes_1.StatusCodes.INTERNAL_SERVER_ERROR : err.statusCode;
        if (responseStatusCode >= http_status_codes_1.StatusCodes.INTERNAL_SERVER_ERROR) {
            if (process.env.NODE_ENV === 'production') {
                errorResponse.message = http_status_codes_1.getReasonPhrase(http_status_codes_1.StatusCodes.INTERNAL_SERVER_ERROR);
            }
            else {
                errorResponse.stacktrace = err.stack;
            }
        }
        res.status(responseStatusCode).json(errorResponse);
    };
};
//# sourceMappingURL=index.js.map